var status = 0;    //ģ״̬
var temp = 0;      //ʱűָ
var temp1 = 0;     //ָ
var CRCH,CRCL;
var size=0;
var TX = new Array(20);
var write_all = new Array(0x01,0x10,0x00,0x02,0x00,0x04,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00);//without status(1 byte) and CRC
var read_all = new Array(0x01,0x03,0x00,0x02,0x00,0x04);                            //without CRC
var answer_read = new Array(0x01,0x03,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00);     //answer read_all,without status(1 byte) and CRC
var answer_write = new Array(0x01,0x10,0x00,0x02,0x00,0x04);                        //response of write,without CRC
var write = new Array(0x01,0x10,0x01,0x02,0x00,0x01,0x02);                          //write one led,must follow led numberstatus and CRC

function crc_j(len)
{
    var j,k;
    var crc = 0xffff;
    k = len - 1;
    while(len--)
    {
        crc = crc ^ TX[k - len];
        for(j=0;j<8;j++)
        {
            if(crc & 0x01 == 1)
            {
                crc = (crc >> 1) ^ 0xA001;
            }
            else crc = crc >> 1;
        }
    }
    CRCH = (crc >> 8) & 0xff;
    CRCL = crc%0x100;
}

function led_on(num)
{
    var i,j;
    for(i=0;i<14;i++)
    {
        TX[i] = write_all[i];
    }
    TX[14] = status;
    switch (num)
    {
        case 0:                 //all on
        {
            TX[14] = 0xFF;
            temp1 = 0;
            break;
        }
        case 1:                 //LED1 on
        {
            TX[14] |= 0x01;
            temp1 = 1;
            break;
        }
        case 2:                 //LED2 on
        {
            TX[14] |= 0x02;
            temp1 = 2;
            break;
        }
        case 3:                 //LED3 on
        {
            TX[14] |= 0x04;
            temp1 = 3;
            break;
        }
        case 4:                 //LED4 on
        {
            TX[14] |= 0x08;
            temp1 = 4;
            break;
        }
        case 5:                 //LED5 on
        {
            TX[14] |= 0x10;
            temp1 = 5;
            break;
        }
        case 6:                 //LED6 on
        {
            TX[14] |= 0x20;
            temp1 = 6;
            break;
        }
        case 7:                 //LED7 on
        {
            TX[14] |= 0x40;
            temp1 = 7;
            break;
        }
        case 8:                 //LED8 on
        {
            TX[14] |= 0x80;
            temp1 = 8;
            break;
        }
        default:
        {
            TX[14] = 0x00;      //all off
            temp1 = 10;
            break;
        }
    }
    status = TX[14];
    crc_j(15);
    TX[15] = CRCL;
    TX[16] = CRCH;
    for(i=0;i<17;i++)
    {
        sysCom0.write(TX[i]);
    }
}

function led_off(num)
{
    var i,j;
    for(i=0;i<14;i++)
    {
        TX[i] = write_all[i];
    }
    TX[14] = status;
    switch (num)
    {
        case 0:                 //all off
        {
            TX[14] = 0x00;
            temp1 = 10;
            break;
        }
        case 1:                 //LED1 off
        {
            TX[14] &= 0xFE;
            temp1 = 11;
            break;
        }
        case 2:                 //LED2 off
        {
            TX[14] &= 0xFD;
            temp1 = 12;
            break;
        }
        case 3:                 //LED3 off
        {
            TX[14] &= 0xFB;
            temp1 = 13;
            break;
        }
        case 4:                 //LED4 off
        {
            TX[14] &= 0xF7;
            temp1 = 14;
            break;
        }
        case 5:                 //LED5 off
        {
            TX[14] &= 0xEF;
            temp1 = 15;
            break;
        }
        case 6:                 //LED6 off
        {
            TX[14] &= 0xDF;
            temp1 = 16;
            break;
        }
        case 7:                 //LED7 off
        {
            TX[14] &= 0xBF;
            temp1 = 17;
            break;
        }
        case 8:                 //LED8 off
        {
            TX[14] &= 0x7F;
            temp1 = 18;
            break;
        }
        default:
        {
            TX[14] = 0x00;      //all off
            temp1 = 10;
            break;
        }
    }
    status = TX[14];
    crc_j(15);
    TX[15] = CRCL;
    TX[16] = CRCH;
    for(i=0;i<17;i++)
    {
        sysCom0.write(TX[i]);
    }
}

function read_sta()
{
    var i;
    for(i=0;i<6;i++)                //read status
    {
        TX[i] = read_all[i];
    }
    crc_j(6);
    TX[6] = CRCL;
    TX[7] = CRCH;
    for(i=0;i<8;i++)
    {
        sysCom0.write(TX[i]);
    }
}

sysCom0.clearReadBuffer();
read_sta();


